/**
 * Back-end JS of Ipban_XH.
 *
 * Copyright (c) 2012 Christoph M. Becker (see license.txt)
 */

(function($) {
    /**
     * The namespace.
     */
    ipban = {
        init: function() {
            $.datepicker.setDefaults($.datepicker.regional[ipban.lang]);
            $('#ipban_grid').jtable({
                messages: ipban.messages,
                title: ipban.texts.bannedIPs,
                paging: !!ipban.page.ban,
                pageSize: ipban.page.ban,
                sorting: true,
                defaultSorting: 'ip asc',
                actions: {
                    listAction: '?&ipban&admin=plugin_main&action=list',
                    createAction: '?&ipban&admin=plugin_main&action=create',
                    updateAction: '?&ipban&admin=plugin_main&action=update',
                    deleteAction: '?&ipban&admin=plugin_main&action=delete'
                },
                fields: {
                    id: {
                        key: true,
                        create: false,
                        edit: false,
                        list: false
                    },
                    ip: {
                        title: ipban.texts.ip,
                        width: '20%',
                        options: '?&ipban&admin=plugin_main&action=ipoptions'
                    },
                    reason: {
                        title: ipban.texts.reason,
                        width: '45%',
                        type: 'textarea'
                    },
                    state: {
                        title: ipban.texts.state,
                        width: '15%',
                        type: 'checkbox',
                        values: {'false': ipban.texts.banned, 'true': ipban.texts.warned}
                    },
                    end: {
                        title: ipban.texts.end,
                        width: '20%',
                        type: 'date'
                    }
                },
            });
            $('#ipban_grid').jtable('load');
            
            $('#ipban_requests').jtable({
                messages: ipban.messages,
                title: ipban.texts.requests,
                paging: !!ipban.page.requests,
                pageSize: ipban.page.requests,
                sorting: true,
                defaultSorting: 'ip asc',
                actions: {
                    listAction: './?&ipban&admin=plugin_main&action=requests'
                },
                fields: {
                    id: {
                        key: true,
                        list: false
                    },
                    ip: {
                        title: ipban.texts.ip,
                        width: '20%'
                    },
                    time: {
                        title: ipban.texts.time,
                        width: '30%'
                    },
                    vars: {
                        title: ipban.texts.vars,
                        width: '50%',
                        sorting: false
                    }
                }
            });
            $('#ipban_filter').click(function (e) {
                e.preventDefault();
                $('#ipban_requests').jtable('load', {
                    'var': $('#ipban_var').val()
                });
            });
            $('#ipban_filter').click();
        }
    }
    
    $(function() {ipban.init()})
})(jQuery)
