<?php

function cmb_json_encode($value)
{
    switch (gettype($value)) {
    case 'boolean':
        return $value ? 'true' : 'false';
    case 'integer':
    case 'double':
        return $value;
    case 'string':
        return '"' . addcslashes($value, "\"\\\b\f\n\r\t") . '"';
    case 'array':
        if (array_keys($value) === range(0, count($value) - 1)) {
            $elts = array();
            foreach ($value as $val) {
                $elts[] = cmb_json_encode($val);
            }
            return '[' . implode(',', $elts) . ']';
        } else {
            $members = array();
            foreach ($value as $key => $val) {
                $members[] = '"' . $key . '":' . cmb_json_encode($val);
            }
            return '{' . implode(',', $members) . '}';
        }
    case 'object':
        return cmb_json_encode(get_object_vars($value));
    case 'NULL':
        return 'null';
    case 'resource':
    default:
        trigger_error('json_encode(): type is unsupported, encoded as null',
                      E_USER_WARNING);
        return null;
    }
}

?>
